/* Des fonctions d'allocations qui font la meme chose que les macros dans
   le cas ou SETUP_FOR_GC et RESTORE_FOR_GC ne font rien.
   Servent a reduire la taille du code.
*/

#include "mlvalues.h"
#include "alloc.h"
#include "stacks.h"

value alloc(size, tag)
     blocksize size;
     int tag;
{
  value res;

  ALLOC(res, MAKE_HEADER(size, tag), size);
  return res;
}

value alloc_tuple(n)
     blocksize n;
{
  return alloc(n, 0);
}

value alloc_double(d)
     double d;
{
  value res;

  SMALL_ALLOC(res, HEADER_FLOAT, SIZE_FLOAT);
  CFLOAT(res) = d;
  return res;
}

value alloc_string(s)
     char * s;
{
  value res;

  ALLOC_STRING(res, strlen(s));
  strcpy(CSTRING(res), s);
  return res;
}

value alloc_string_array(nbr, arr)
     int nbr;
     char * arr [];
{
  value v;
  int n;

  if (nbr <= 0) {
    v = atom(0);
  } else {
    while (extern_asp - nbr <= arg_stack_low)
      realloc_stacks();
    for (n = 0; n < nbr; n++)
      *--extern_asp = alloc_string(arr[n]);
    v = alloc_tuple(nbr);
    for (n = nbr - 1; n >= 0; n--)
      FIELD(v, n) = *extern_asp++;
  }
  return v;
}

